/***************************************************************************
 *   Copyright (C) 2008 by lovewilliam   *
 *   lovewilliam@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "antibackend.h"
#include "globVar.h"

#include <kdebug.h>

antiBackend::antiBackend()
{
	pcmBackend = new pcmx();
}


antiBackend::~antiBackend()
{
	pcmBackend->pcmxStop();
	pcmBackend->exit();
	pcmBackend->wait();
#ifdef _DEBUG_
	kdDebug()<<"pcmx Backend exited?"
			<<((pcmBackend->finished())?"Yes":"No")<<endl;
#endif

	delete pcmBackend;
}

void antiBackend::start ( int lev )
{
	pcmBackend->changeLevel(lev);
	pcmBackend->start();
}

void antiBackend::stop ( void )
{
	pcmBackend->pcmxStop();
	pcmBackend->wait();
#ifdef _DEBUG_
	kdDebug()<<"pcmx Backend exited?"
			<<((pcmBackend->finished())?"Yes":"No")<<endl;
#endif
}

void antiBackend::changeLevel ( int lev )
{
	pcmBackend->changeLevel(lev);
}
