/***************************************************************************
 *   Copyright (C) 2008 by lovewilliam   *
 *   lovewilliam@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <kmainwindow.h>
#include <klocale.h>

#include <kiconloader.h>
#include <kicontheme.h>
/*Example:
KIconLoader &loader = *KGlobal::iconLoader();
 QPixmap pixmap = loader.loadIcon( "help" );
 toolBar(0)->insertButton( pixmap, 0, SIGNAL(clicked()),
   this, SLOT(appHelpActivated()), true, i18n("Help") );
*/
#include <kaboutapplication.h>
#include <kpopupmenu.h>

#include "globVar.h"

#ifdef _DEBUG_
#include <kdebug.h>
#endif

#include <qtooltip.h>

#include "antimoz.h"
#include "antimozwidget.h"

static char charLevel[][2] = {"1","2","3","4","5"};

Antimoz::Antimoz()
    : KMainWindow( 0, i18n("Antimoz") )
{

	started = FALSE;

	KIconLoader *loader = new KIconLoader("Antimoz",0);

	anti = new AntimozWidget(this);
	connect(anti,SIGNAL(toTray()),this,SLOT(hide()));
	this->setCentralWidget( anti );
	tray = new KSystemTray(this, i18n("Antimoz !"));
	tray->setPixmap(loader->loadIcon("antimoz",
  					KIcon::Small,
  					KIcon::SizeSmall,
  					KIcon::DefaultState, 
  					0,
  					FALSE  ));

	tray->show();

	about = new KAction(i18n("About"),
		"antimoz",
		0,
		this,
		"about"
	);
	about->plug( tray->contextMenu(),1);
	connect( about, SIGNAL(activated()),this,SLOT(aboutShow()));

	startButton = new KAction(i18n("Start !"),
		"antiStart",
		0,
		this,
		"Start"
	);
	startButton->plug( tray->contextMenu(),2);
	connect( startButton, SIGNAL(activated()),anti,SLOT(startButtonClicked()));
	connect( startButton, SIGNAL(activated()),this,SLOT(setSBText()));
	connect( anti,SIGNAL ( changeText() ),this,SLOT ( setSBText( ) ) );
	QToolTip::add(tray,i18n("Antimoz Stopped."));

}

Antimoz::~Antimoz()
{
}

void Antimoz::aboutShow()
{
	KAboutApplication * aboutApp=new KAboutApplication(this,i18n("About Antimoz!"));
	aboutApp->exec();
	delete aboutApp;
}

void Antimoz::setSBText()
{
#ifdef _DEBUG_
kdDebug()<<"Deal begin"<<started<<endl;
#endif
	if ( started )
	{
		startButton->setText(i18n("Start !"));
		QToolTip::add(tray,i18n("Antimoz Stopped."));
	}
	else
	{
		startButton->setText ( i18n ( "Stop !" ) );
		QToolTip::add(tray,i18n("Antimoz is running at Level ")
							+charLevel[anti->antiLevel-1]);
	}
#ifdef _DEBUG_
kdDebug()<<"Deal end"<<started<<endl;
#endif
	started = !started;
#ifdef _DEBUG_
kdDebug()<<"changing state Done"<<started<<endl;
#endif
}

#include "antimoz.moc"
