/***************************************************************************
 *   Copyright (C) 2008 by lovewilliam   *
 *   lovewilliam@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "globVar.h"

#include "antimozwidget.h"

#include <qradiobutton.h>
#include <qpushbutton.h>
#include <qlcdnumber.h>
#include <qobject.h>

#ifdef _DEBUG_
#include <kdebug.h>
#endif

#include <klocale.h>


static int levels[]={16000,17000,18000,19000,20000};

AntimozWidget::AntimozWidget ( QWidget* parent, const char* name, WFlags fl )
		: AntimozWidgetBase ( parent,name,fl )
{

	antiLevel = 1;

	started = FALSE;
	antiback = new antiBackend();

	connect ( radioButton1,SIGNAL ( clicked() ),this,SLOT ( radioButtonClicked1() ) );
	connect ( radioButton2,SIGNAL ( clicked() ),this,SLOT ( radioButtonClicked2() ) );
	connect ( radioButton3,SIGNAL ( clicked() ),this,SLOT ( radioButtonClicked3() ) );
	connect ( radioButton4,SIGNAL ( clicked() ),this,SLOT ( radioButtonClicked4() ) );
	connect ( radioButton5,SIGNAL ( clicked() ),this,SLOT ( radioButtonClicked5() ) );

	connect ( this,SIGNAL ( radioBC ( int ) ),this,SLOT ( radioButtonClicked ( int ) ) );

	connect ( quitButton,SIGNAL ( clicked() ),this,SLOT ( quitButtonClicked ( void ) ) );
	connect ( trayButton,SIGNAL ( clicked() ),this,SLOT ( trayButtonClicked ( void ) ) );
	connect ( startButton,SIGNAL ( clicked() ),this,SLOT ( startButtonClicked ( void ) ) );
	connect ( startButton,SIGNAL ( clicked() ),this,SLOT ( toParent(void) ) );

}

AntimozWidget::~AntimozWidget()
{
}

/*$SPECIALIZATION$*/

void AntimozWidget::quitButtonClicked ( void )
{
	antiback->stop();
	exit ( 0 );
}

void AntimozWidget::startButtonClicked ( void )
{
// 	emit changeText();
	if ( !started )
	{
		lcdNum->display ( levels[antiLevel-1] );
		antiback->start ( antiLevel );
		startButton->setText ( i18n ( "&Stop" ) );
	}
	else
	{
		lcdNum->display ( 0 );
		antiback->stop();
		startButton->setText ( i18n ( "&Start" ) );
	}
	started = !started;
}

void AntimozWidget::trayButtonClicked ( void )
{
	emit toTray();
}

void AntimozWidget::radioButtonClicked ( int l )
{

#ifdef _DEBUG_
	kdDebug() <<"LEVEL"<<l<<endl;
#endif
	lcdNum->display ( levels[l-1] );

	antiLevel = l;
	antiback->changeLevel ( antiLevel );
}

void AntimozWidget::radioButtonClicked1 ( void )
{
	emit radioBC ( 1 );
}

void AntimozWidget::radioButtonClicked2 ( void )
{
	emit radioBC ( 2 );
}

void AntimozWidget::radioButtonClicked3 ( void )
{
	emit radioBC ( 3 );
}

void AntimozWidget::radioButtonClicked4 ( void )
{
	emit radioBC ( 4 );
}

void AntimozWidget::radioButtonClicked5 ( void )
{
	emit radioBC ( 5 );
}

void AntimozWidget::toParent(void )
{
	emit changeText();
}


#include "antimozwidget.moc"
