/***************************************************************************
 *   Copyright (C) 2008 by lovewilliam   *
 *   lovewilliam@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PCMX_H
#define PCMX_H

#include <qthread.h>


#include <alsa/asoundlib.h>

/**
	@author lovewilliam <lovewilliam@gmail.com>
*/
class pcmx : public QThread
{
	public:
		pcmx();
		static int write_loop ( snd_pcm_t *handle,
		                        signed short *samples,
		                        snd_pcm_channel_area_t *areas );
		virtual void run();
		~pcmx();
		void pcmxStop(void);
		void changeLevel(int lev);
		int antiLevel;
// 		bool pcmStop;
		

	private:
		int callPcm ( int );
		static void generate_sine ( const snd_pcm_channel_area_t *areas,
		                            snd_pcm_uframes_t offset,
		                            int count, double *_phase );
		static int set_hwparams ( snd_pcm_t *handle,
		                          snd_pcm_hw_params_t *params,
		                          snd_pcm_access_t access );
		static int set_swparams ( snd_pcm_t *handle, snd_pcm_sw_params_t *swparams );
		static int xrun_recovery ( snd_pcm_t *handle, int err );

};

#endif
